export declare type UseAsyncProps<ExecPayload = any, ResultSchema = any> = {
    fn: (props: ExecPayload) => any | ((props: ExecPayload) => Promise<any>);
    autoExec?: boolean;
    defaultData?: ResultSchema;
    defaultPayload?: ExecPayload;
    additionalPayload?: ExecPayload;
    onResult?: (props: {
        result: ResultSchema;
    }) => any;
    onError?: (props: {
        error: any;
    }) => any;
    onLoading?: (props: {
        loading: boolean;
    }) => any;
};
export declare type UseAsyncReturn<ExecPayload = any, ResultSchema = any> = {
    loading: boolean;
    error: any;
    result: ResultSchema;
    exec: (payload?: ExecPayload | undefined) => void;
};
/**
 * @example
 * const promise = useAsync({
 * fn
 * })
 */
export default function useAsync<ExecPayload, ResultSchema>({ fn, autoExec, defaultData, defaultPayload, additionalPayload, onResult, onError, onLoading, }: UseAsyncProps<ExecPayload, ResultSchema>): UseAsyncReturn<ExecPayload, ResultSchema>;
